; +++++++++ Customized toolbar example ++++++++++
; ++++++++++ Programmed by Luis Costa +++++++++++
; ++++++++++++++ Lisbon,Postugal ++++++++++++++++
; ++++++++++++  xandaz@hotmail.com ++++++++++++++

useMB=0	; MasmBasic download: http://www.masm32.com/board/index.php?topic=12460
if useMB
	include \masm32\MasmBasic\MasmBasic.inc 
else
	include \masm32\include\masm32rt.inc

	deb MACRO num, txt, args:VARARG	; poor substitute for the MasmBasic deb macro
	pushad
	print &txt&, 9
	FOR arg, <args>
;	% echo arg
		push arg
		pop eax
		print str$(eax), 9
	ENDM
	print chr$(13, 10)
	popad
	ENDM
endif

WinMain	PROTO :DWORD,:DWORD,:DWORD,:DWORD
CbMenu	PROTO :DWORD,:DWORD,:DWORD

.const
IdMenuNew	= 1000			; ID menu item New
IdMenuSave	= 1001			; ID menu item Save
IdMenuCopy	= 1100			; ID menu item Copy

NMTBCUSTOMDRAW STRUCT
    nmcd                 NMCUSTOMDRAW <>
    hbrMonoDither        dd ?
    hbrLines             dd ?
    hpenLines            dd ?
    clrText              dd ?
    clrMark              dd ?
    clrTextHighlight     dd ?
    clrBtnFace           dd ?
    clrBtnHighlight      dd ?
    clrHighlightHotTrack dd ?
    rcText               RECT <>
    nStringBkMode        dd ?
    nHLStringBkMode      dd ?
    iListGap             dd ?
NMTBCUSTOMDRAW ENDS

if 1
	CWPSTRUCT STRUCT
	lParam	LPARAM ?
	wParam	WPARAM ?
	message	UINT ?
	hwnd	HWND ?
	CWPSTRUCT ENDS
endif
 
MainWindowWidth     equ     400
MainWindowHeight    equ     350

NoButtons           equ     6
DRAW_GRIPPER        equ     0100h
WS_TOOLBAR          equ     WS_VISIBLE+WS_CHILD+TBSTYLE_CUSTOMERASE+TBSTYLE_FLAT

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Customized Toolbar',0
hMenu	HWND ?
ghM3	dd ?
hEdit	dd ?
msgCount	dd ?
opSubClass	dd ?
wMenu	dd ?
smHandle	dd ?
flagCmb	dd ?
hMboxHook	dd ?

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW+CS_DROPSHADOW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ Toolbar related +++++

hToolbar        dd      ?
ToolbarClass    db      'ToolbarWindow32',0
TBButtons       TBBUTTON        <0,20h,TBSTATE_ENABLED,BTNS_SEP,DRAW_GRIPPER,1>
                TBBUTTON        <0,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>                        
                TBBUTTON        <0,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,3,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,4,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                
hMemDC      HDC     ?
hDC         HDC     ?
rect        RECT        <>
BmpHandles      dd      10 dup(?)

.code
    start:
    invoke InitCommonControls
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
    local   msg:MSG
    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    add eax, 300
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_VISIBLE,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret
WinMain     endp
IdEdit	= 2000
WndProc PROC uses ebx    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL hM1:HWND, hM2:HWND, mbi:MENUINFO
    local   BtnSize:WORD
    local   wcx:WNDCLASSEX
  inc msgCount
  .if 0 ;uMsg!=WM_NCMOUSEMOVE && uMsg!=WM_NCHITTEST && uMsg!=WM_SETCURSOR
;	deb 4, str$(msgCount), chg:uMsg
  .endif
    .if uMsg==WM_CLOSE
	invoke UnhookWindowsHookEx, hMboxHook	; unhook on close
;	push eax
;	mov eax, LastError$()
;	pop edx
;	deb 1, "UnHook in close", edx, hMboxHook, $eax
	invoke DestroyWindow, hWnd
	return 0
    .elseif uMsg==WM_DESTROY
	invoke PostQuitMessage, NULL
    .elseif 0 ;uMsg==WM_INITMENUPOPUP
    	invoke FindWindow, 32768, 0
    	push eax
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("edit"), NULL, 
			WS_CHILD or WS_VISIBLE or WS_BORDER	or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE,
			400, -10, 100, 24,
			hMainWindow, IdEdit, hInstance, NULL
		mov hEdit, eax							; we have created an edit window
;	invoke SetWindowLong, eax,			; we subclass the menu
;	GWL_WNDPROC, SubMenu
	mov eax, LastError$()
	pop edx
;    	deb 1, "Gotcha", $eax, edx, hEdit
    .elseif uMsg==WM_GETTITLEBARINFOEX	; Vista only?
    	deb 1, "info", eax
    .elseif uMsg==WM_WINDOWPOSCHANGED
    	mov ebx, lParam
    	deb 4, "posc", [ebx.WINDOWPOS.lx], [ebx.WINDOWPOS.cy]
;    	mov [ebx.WINDOWPOS.lx], 100
;    	return 1	; no effect
    .elseif uMsg==WM_KEYDOWN
    	.if wParam==VK_ESCAPE
    		invoke SendMessage, hWnd, WM_CLOSE, 0, 0

    	.elseif wParam==VK_F1
;    		mov mbi.cbSize, MENUINFO		; menurect WM_ENTERIDLE showmenu
;    		invoke GetMenuInfo, hMenu, addr mbi
;    		mov mbi.fMask, MIM_BACKGROUND or MIM_APPLYTOSUBMENUS
;    		mov mbi.hbrBack, rv(GetStockObject, WHITE_BRUSH)
;    		invoke SetMenuInfo, hMenu, addr mbi
    		invoke DrawMenuBar, hWnd
    		deb 4, "Brush", mbi.hbrBack
	if 0
	  	invoke FindWindow, 32768, 0
	  	mov wMenu, eax
;	  	invoke ShowWindow, eax, SW_MAXIMIZE
	  	.if !hEdit
		; invoke GetMenu, hWnd
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("edit"), NULL, 
				WS_CHILD or WS_VISIBLE or WS_BORDER or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE,
				80, 0, 150, 24,
				wMenu, IdEdit, hInstance, NULL
			mov hEdit, eax							; we have created an edit window
;			invoke SetParent, eax, wMenu
			deb 4, "SP", $Err$()
			invoke SetFocus, hEdit
			SetWin$ hEdit="What a nice day"
			deb 4, "SP", $Win$(hEdit)
			invoke ShowWindow, hEdit, SW_RESTORE	; no effect
		.endif
;		invoke GetMenu, hWnd
;		invoke ShowWindow, eax, SW_MINIMIZE
		deb 4, "Edit", hEdit, wMenu, eax, smHandle
	endif
	.else
		deb 4, "Key", eax
    	.endif
    .elseif uMsg==WM_CREATE
	invoke GetCurrentThreadId	; shorter than GetWindowThreadProcessId, hWnd, 0
	invoke SetWindowsHookEx, WH_CALLWNDPROC, CbMenu, 0, eax
	mov hMboxHook, eax
	deb 4, "ResHook", eax

		mov hMenu, rv(CreateMenu)				; create the main menu
	  	invoke FindWindow, 32768, 0		; Menus are a system global class -> [url=http://www.visual-basic.com.ar/vbsmart/library/smartmenuxp/smartmenuxp.htm]hooks[/url]
	  	mov wMenu, eax
	  	deb 4, "CREATE", hMenu, wMenu
;		int 3
;	  	invoke GetWindowLong, eax, GWL_STYLE
;	  	mov edx, eax
;	  	or eax, WS_CLIPCHILDREN
;	  	deb 4, "Style", eax, edx
;	  	invoke SetWindowLong, wMenu, GWL_STYLE, eax
	  	push eax
	  	mov eax, LastError$()
	  	pop edx
;	  	deb 4, "Mist", $eax, edx
		
		mov hM1, rv(CreateMenu)				; plus three
		mov hM2, rv(CreateMenu)				; sub menus
;		mov ghM3, rv(CreateMenu)
		invoke AppendMenu, hMenu, MF_POPUP	, hM1, chr$("&File")
		invoke AppendMenu, hM1, MF_STRING, IdMenuNew, chr$("&New",9,"Ctrl+N")
		invoke AppendMenu, hM1, MF_STRING, IdMenuSave, chr$("&Save",9,"Ctrl+S")
		invoke AppendMenu, hMenu, MF_POPUP, hM2, chr$("&Edit")
		invoke AppendMenu, hM2, MF_STRING, IdMenuCopy, chr$("&Copy",9,"Ctrl+C")
	  	; SetWin$ wMenu="Hello"			; no effect
		invoke SetMenu, hWnd, hMenu			; attach menu to main window
		mov smHandle, eax
	mov edi, lParam
        .if     [edi.CREATESTRUCT].hWndParent==NULL

            invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_TOOLBAR OR CCS_NOMOVEY,\
                    0,24,0,0,hWnd,0100h,hInstance,NULL
            mov     hToolbar,eax
            invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
            invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
            invoke  SendMessage,hToolbar,TB_SETBUTTONSIZE,NULL,200020h
            invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL

    		mov mbi.cbSize, MENUINFO		; menurect WM_ENTERIDLE showmenu
    		invoke GetMenuInfo, hMenu, addr mbi
    		mov mbi.fMask, MIM_BACKGROUND or MIM_APPLYTOSUBMENUS
    		mov mbi.hbrBack, rv(GetStockObject, WHITE_BRUSH)
    		invoke SetMenuInfo, hMenu, addr mbi

;		IdEdit	= 2000
;		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("edit"), NULL, 
;			WS_CHILD or WS_VISIBLE or WS_BORDER	or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE,
;			400, -10, 100, 24,
;			hWnd, IdEdit, hInstance, NULL
;		mov hEdit, eax							; we have created an edit window
            mov     esi,0100
            lea     edi,BmpHandles
            mov     ecx,15
            cld
bmp_loop:
            push    ecx
            invoke  LoadBitmap,hInstance,esi
            stosd
            pop     ecx
            dec     ecx
            jcxz    end_bmp_loop
            inc     esi
            jmp     bmp_loop
end_bmp_loop:            
            
        .endif    
    .elseif uMsg==WM_NOTIFY
        mov     edi,lParam
        .if     [edi.NMTBCUSTOMDRAW].nmcd.hdr.code==NM_CUSTOMDRAW
           .if      [edi.NMTBCUSTOMDRAW].nmcd.dwDrawStage==CDDS_PREPAINT
                mov     eax,CDRF_NOTIFYITEMDRAW+TBCDRF_NOBACKGROUND
                ret
            .elseif [edi.NMTBCUSTOMDRAW].nmcd.dwDrawStage==CDDS_ITEMPREPAINT
                invoke  CreateCompatibleDC,[edi.NMTBCUSTOMDRAW].nmcd.hdc
                mov     hMemDC,eax
                mov     eax,[edi.NMTBCUSTOMDRAW].nmcd.dwItemSpec
                shl     eax,3
                lea     esi,BmpHandles
                add     esi,eax
                test    [edi.NMTBCUSTOMDRAW].nmcd.uItemState,CDIS_SELECTED
                jz      unselected
                add     esi,4
                invoke  SelectObject,hMemDC,dword ptr [esi]
                jmp     draw
unselected:               
                invoke  SelectObject,hMemDC,dword ptr [esi]
draw:
                lea     esi,[edi.NMTBCUSTOMDRAW].nmcd.rc
                assume  esi:PTR RECT
                invoke  StretchBlt,[edi.NMTBCUSTOMDRAW].nmcd.hdc,[edi.NMTBCUSTOMDRAW].nmcd.rc.left\
                ,[edi.NMTBCUSTOMDRAW].nmcd.rc.top,[edi.NMTBCUSTOMDRAW].nmcd.rc.right\
                ,[edi.NMTBCUSTOMDRAW].nmcd.rc.bottom,hMemDC,0,0,[esi].right,[esi].bottom,SRCCOPY
end_draw:                
                invoke  DeleteDC,hMemDC
                mov     eax,CDRF_SKIPDEFAULT
                ret                               
                                            
            .endif
        .endif                                               
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret
WndProc     endp

CbMenu proc uses esi edi ebx nCode:DWORD, wParam:DWORD, lParam:DWORD
LOCAL cname[127]:BYTE
	.if nCode!=HC_ACTION
		deb 1, "Cb not action", nCode, HC_ACTION
	.endif
	mov esi, lParam
;	deb 4, "CbMenu", lParam
	.if esi && nCode==HC_ACTION
		mov eax, [esi.CWPSTRUCT.message]		; [url=http://www.visual-basic.com.ar/vbsmart/library/smartmenuxp/smartmenuxp.htm]SmartXP[/url] control
		.if eax==WM_CREATE
			lea edi, cname
			invoke GetClassName, [esi.CWPSTRUCT.hwnd], edi, 127
			if useMB
				deb 4, "Class", $edi
			endif
			mov ecx, [esi.CWPSTRUCT.hwnd]
			.if ecx==wMenu || ecx==32768
				deb 1, "Gotcha", eax, ecx	; never seen
			.else
				deb 4, "No luck", ecx, hMainWindow, wMenu, hMenu
			.endif
		.endif
	.endif
;	.if nCode==HCBT_CREATEWND ;&& flagCmb==0
;	.if nCode==HCBT_ACTIVATE && flagCmb==0
;		inc flagCmb
;		invoke SetWindowLong, wParam, GWL_WNDPROC, SubMenu
;		mov opSubClass, eax
;		deb 1, "Class", opSubClass, nCode, hMenu, wMenu
;		invoke UnhookWindowsHookEx, hMboxHook	; unhook immediately ******************
;	.endif
	invoke CallNextHookEx, hMboxHook, nCode, wParam, lParam
	ret
CbMenu endp

SubMenu proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		mov eax, hwnd
		.if eax==wMenu || eax==hMenu
			deb 1, "Gotcha", wMenu, hMenu
		.endif
  .if uMsg!=WM_NCMOUSEMOVE && uMsg!=WM_NCHITTEST && uMsg!=WM_SETCURSOR
	deb 4, "## CB menu", uMsg
;	deb 4, "Menu msg", chg:uMsg
  .endif
	SWITCH uMsg
	CASE WM_CREATE
		deb 4, "Ciao", eax
	CASE WM_SIZE
		mov eax, hwnd
		.if eax==wMenu
			deb 1, "Size", hwnd, wMenu, hMainWindow
			return 0
		.endif
	CASE WM_SYNCPAINT
		deb 4, "Sync", eax
;	CASE WM_CHAR
;	deb 4, "Char", eax
;		.if wParam==VK_RETURN				; user hit Enter
;			xor eax, eax
;			ret									; return 0 to suppress the insertion of a new line
;		.endif
;	CASE WM_KEYUP
;	nop
	ENDSW
; subclassing finished, continue with default handler
  invoke CallWindowProc, opSubClass, hwnd, uMsg, wParam, lParam
  ret
SubMenu endp
end start                                            

RichMasm options:
OPT_Tmp2asm	1
OPT_Susy	Console
OPT_Wait	0
OPT_Assembler	ml
